<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class attachment
{
private $uid=false;
private $edittime=false;
private $admin=false;
private $site;
private $con;
function __construct()
{
        $message=$this->connection();
		if((($this->site['blocksite'])&&(!$this->admin))||($message!==true)){exit;}
        if((!isset($_COOKIE['lastin']))||(!preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['lastin'])))||(trim($_COOKIE['lastin'])<(time()-5*3600))){exit;}
}
private function connection()
{
        include 'database/config.php';
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return true;
}
private function validate_user()
{
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result = $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
		if(isset($_COOKIE['fw_login'])&&fw_validate_session($_COOKIE['fw_login'])){
            $login=explode('-',$_COOKIE['fw_login']);
			$id=(int)$login[0];
			$session=$login[1];
            $query=sprintf("SELECT session, edittime FROM ".PREFIX."user WHERE id = %u AND level='C'",$id);
            $result = $this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
            if((!empty($row['session']))&&(md5($row['session'])===$session)){
				$this->uid=$id;
				if($row['edittime']>(time()-3600)){$this->edittime=true;}
			}
		}
		$result->free();
}
public function get_file()
{
		$id=((isset($_GET['id']))&&(preg_match('/^[0-9]{1,5}$/u', trim($_GET['id']))))? (int)($_GET['id']):0;
		if(!$id){return;}
		$query=sprintf("SELECT* FROM ".PREFIX."upload WHERE id = %u",$id);
		$result = $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		if(!$this->verify_call($row['pid'])){return;}
		$filename=$row['name'].'.zip';
		$content=@file_get_contents('files/.'.$row['pname']);
		if(empty($content)){return;}
		if($row['compressed']){
			if(($this->uid)||($this->site['fileaccess'] === 'A')){
				$this->con->query(sprintf("UPDATE ".PREFIX."upload SET download = download + 1 WHERE id = %u",$id));
				header("Content-type: application/zip");
				header("Content-Disposition: attachment; filename=$filename");
				echo $content;}
		}
		else{
			if(($this->admin)||($this->uid)||($this->site['fileaccess'] === 'A')||($this->site['fileaccess'] === 'I')){
				$type=$row['type'];
				header("Content-type: $type");
				echo $content;}	
		}
}
private function verify_call($id)
{
		if(($this->admin)||($this->edittime)){return true;}
		$query=sprintf("SELECT tc.id AS cid, tc.pid, tp.id AS postid FROM ".PREFIX."post tc LEFT JOIN (SELECT id FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0) AS tp ON tc.pid = tp.id WHERE tc.publish = 'Y' AND tc.id = %u",$id);
		$result = $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		if($row['cid']){if((!$row['pid'])||(($row['pid'])&&($row['postid']))){return true;}}
		return false;
}
}
?>