<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class user extends clslogin
{
private function usercp($message='')
{
		$query=sprintf("SELECT* FROM ".PREFIX."user WHERE id = %d",$this->uid);
		$result=@$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		$disabled_email=(!$this->site['allowemail']);
		$verify_user=$this->site['verifyuser'];
		$title='UserCP :: '.$row['user'];
		$menu=$this->get_menu();
		$scriptfile='<script type="text/javascript" src="../script/user.js"></script><script type="text/javascript">var bbCodeEditorID="signature";var maxCodeLength=250;</script>';
		$maxlink=($this->site['linkpersign'])? $this->site['linkpersign'].' url maximum' : 'No url allowed';
		include "include/head.php";
		include "include/usercp.php";
		include "include/footer.html";
}
private function save_user()
{
		$autolink=(isset($_POST["autolink"])&&($_POST["autolink"]=='Y'))? 1 : 0;
		$signature=xss_cleaner(trim(fw_strip_slashes(rawurldecode($_POST["signature"]))));
		if(substr_count($signature,"\n")>2){fw_message(true,'Error! Maximum 3 new line allowed in signature');exit;}
		$s=fw_bb2text($signature);
		if(strlen($s)>100){fw_message(true,'Error! Signature text length must be within 100 characters. Now it is '.strlen($s));exit;}
		$s=fw_linkcount($signature,$autolink);
		if($s>$this->site['linkpersign']){fw_message(true,'Error! Maximum '.$this->site['linkpersign'].' URL allowed in signature');exit;}
		$website=trim(fw_strip_slashes(rawurldecode($_POST["website"])));
		if(!empty($website)){if(!verify_url($website)){$message='<span style="color:red">Error! Use good url</span>';}}
		if($message){$this->usercp($message);exit;}
		$email=trim(fw_strip_slashes($_POST["email"]));
		$password=trim(fw_strip_slashes($_POST["cpw"]));
		$newpassword=trim(fw_strip_slashes($_POST["npw"]));
		$allowemail=(isset($_POST["allowemail"])&&($_POST["allowemail"]=='Y'))? 'Y' : '';
		$query=sprintf("SELECT* FROM ".PREFIX."user WHERE id = %d",$this->uid);
		$result=@$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		$query=sprintf("UPDATE ".PREFIX."user set signature = '%s', website = '%s', allowemail = '$allowemail', autolink = $autolink",$this->con->real_escape_string($signature),$this->con->real_escape_string($website));
		if((!empty($password))&&(fw_validate_password($newpassword))&&($row['password']===md5($password))){$query.=sprintf(", password = '%s'",$this->con->real_escape_string(md5($newpassword)));}
		$verification_email='';
		if($email!==$row['email']){
			if(!fw_validate_email($email)){fw_message(true,'Error! Invalid email address!');exit;}
			else{
				if($this->site['verifyuser']){
					if(!($this->mail_email_change($email,$row['name'],$this->uid))){fw_message(true,'System error! Please  contact site administrator.');exit;}
					$verification_email='<br />A verification email has been sent to your new email address.';}
				else{$query.=sprintf(", email = '%s'",$this->con->real_escape_string($email));}
			}
		}
		$query.=sprintf(" WHERE id = %d",$this->uid);
		if(!(@$this->con->query($query))){fw_message(true,'Error: '.$this->con->error);}
		else{fw_message(false,'Data has been successfully updated'.$verification_email);}exit;
}
public function get_query($qur)
{
		$message='';
		if($this->verify_user($message)){
			switch ($qur[1]){
				case "1":
					$this->usercp($qur[2]);
				break;
				case "2":
					$this->save_user();
				break;
				case "5":
					$this->log_out();
				break;
				default:
					$this->usercp();
			}
		}
		else{
			if($qur[1]!="2"){$this->log_in($message);}
			else{@header("Location: index.php");}
		}
}
}
?>